<?php 
class PaymentGogopay extends Payment {
	function __construct(&$locator) {
		$this->address  =& $locator->get('address');
		$this->cart     =& $locator->get('cart');
		$this->config   =& $locator->get('config');
		$this->currency =& $locator->get('currency');
		$this->customer =& $locator->get('customer');
		$this->database =& $locator->get('database');
		$this->language =& $locator->get('language');
		$this->mail     =& $locator->create('mail');
		$this->order    =& $locator->get('order');
        $this->request  =& $locator->get('request');
        $this->response =& $locator->get('response');
		$this->session  =& $locator->get('session');
		$this->shipping =& $locator->get('shipping');
		$this->tax      =& $locator->get('tax');
		$this->url      =& $locator->get('url');	    
		
		$this->language->load('extension/payment/gogopay.php');
  	}
  
	function getTitle() {
		return $this->language->get('text_gogopay_title');
  	}
   
  	function getMethod() {
		if ($this->config->get('gogopay_status')) {
      		if (!$this->config->get('gogopay_geo_zone_id')) {
        		$status = true;
      		} elseif ($this->database->getRows("select * from zone_to_geo_zone where geo_zone_id = '" . (int)$this->config->get('gogopay_geo_zone_id') . "' and country_id = '" . (int)$this->address->getCountryId($this->session->get('payment_address_id')) . "' and (zone_id = '" . (int)$this->address->getZoneId($this->session->get('payment_address_id')) . "' or zone_id = '0')")) {
      		  	$status = true;
      		} else {
     	  		$status = false;
			}	
      	} else {
			$status = false;
		}
		
		$method_data = array();
	
		if ($status) {  
      		$method_data = array( 
        		'id'         => 'gogopay',
        		'title'      => $this->language->get('text_gogopay_title'),
				'sort_order' => $this->config->get('gogopay_sort_order')
      		);
    	}
   
    	return $method_data;
  	}

    function process() {
        $this->order->load($this->order->getReference());
        $sql = "select `order_status_id` from `order_status` where `name` = '?' and `language_id` = '?'";
        $parsed = $this->database->parse($sql, $this->language->get('order_status_paid_unconfirmed'), $this->language->getId()); 
        $results = $this->database->getRow($parsed);
        if (!$results) {
			//$this->response->redirect($this->url->ssl('checkout_failure'));
            die('Configuration error: You MUST have created an order status for "Paid Unconfirmed" for every installed language. The following sql statement returned no rows ' . $parsed);
        }
		$this->order->process($results['order_status_id']);
    }
 
  	function getActionUrl() {
		return $this->config->get('gogopay_test')?
			'https://www.gogopay.com/PaymentGateway/PGOsCommerce.aspx':
			'https://www.gogopay.com/PaymentGateway/PGOsCommerce.aspx';
	}
    
  	function fields() {	
		$currency_data = explode(',', $this->config->get('gogopay_currency'));
		
		if (in_array($this->currency->getCode(), $currency_data)) {
			$currency = $this->currency->getCode();
		} else {
			$currency = $this->config->get('config_currency');
		}
		
		$OrderLine='';
		foreach ($this->order->get('products') as $product) {
	    //for ($i=0, $n=sizeof($this->order->get('products')); $i<$n; $i++) {
    	$pname = $product['name'];
		$pqty = $product['quantity'];
		$price = $product['price'];
		$OrderLine .= $pname . ',' . $pqty . ',' . $price . '##';
	    }

		$fields=array();
		$fields['cmd']='_xclick';
		$fields['username']=$this->config->get('gogopay_loginID');
		$fields['password']=$this->config->get('gogopay_password');
		$fields['currency_code']=$currency;
		$fields['amount']=$this->currency->format($this->order->get('total'), $currency, FALSE, FALSE);
		$fields['UniversalDTOT']= date('m/d/y H:i:s A');
		$fields['feebearer'] = "";
		$fields['capturemode']="";
		$fields['MerchantTransactionID']=$this->order->getReference();
		$fields['BillingDetailsSupplied']="1";
		$fields['billingfirstname']= $this->order->get('firstname');
		$fields['billinglastname']= $this->order->get('lastname');
		$fields['billingaddress1']= $this->order->get('payment_address_1');
		$fields['billingaddress2']= $this->order->get('payment_address_2');
		$fields['billingcity']= $this->order->get('payment_city');
		$fields['billingstate']= $this->order->get('payment_zone');
		$fields['billingcountry']= $this->order->get('payment_country');
		$fields['billingzip']= $this->order->get('payment_postcode');
		$fields['billingphone']= $this->order->get('telephone');
		$fields['ShippingDetailsSupplied']="1";
		$fields['shippingfirstname']= $this->order->get('shipping_firstname');
		$fields['shippinglastname']= $this->order->get('shipping_lastname');
		$fields['shippingaddress1']= $this->order->get('shipping_address_1');
		$fields['shippingaddress2']= $this->order->get('shipping_address_2');
		$fields['shippingcity']= $this->order->get('shipping_city');
		$fields['shippingstate']= $this->order->get('shipping_zone');
		$fields['shippingcountry']= $this->order->get('shipping_country');
		$fields['shippingzip']= $this->order->get('shipping_postcode');
		$fields['shippingphone']= $this->order->get('telephone');
		
		$fields['orderline']= $OrderLine;
		$fields['successurl']=$this->url->ssl('checkout_process');
		$fields['cancelurl']=$this->url->ssl('checkout_payment');
		$fields['isadult']="";
		$fields['CustomerEmailID']=$this->order->get('email');
		$fields['notify_url']=$this->url->ssl('checkout_process', 'callback', array('payment' => 'gogopay'));
		$fields['paymentaction']='authorization';

		$output=array();
		foreach ($fields as $key => $value) {
			$output[]='<input type="hidden" name="'.$key.'" value="'.$value.'">';
		}

		$output=implode("\n",$output);
	
    	return $output;
  	}

	function callback() {
		$req = 'cmd=_notify-validate';

		foreach ($_POST as $key => $value) {
			$req .= '&' . $key . '=' . urlencode(stripslashes($value));
		}

		$header  = 'POST /cgi-bin/webscr HTTP/1.0' . "\r\n";
		$header .= 'Content-Type: application/x-www-form-urlencoded' . "\r\n";
		$header .= 'Content-Length: ' . strlen($req) . "\r\n\r\n";
		
		$url=$this->config->get('gogopay_test')?'ssl://www.gogopay.com':'ssl://www.gogopay.com';
		$fp = fsockopen($url, 443, $errno, $errstr, 30);
		
		if ($fp) {
			fputs($fp, $header . $req);			
			while (!feof($fp))
				$res = fgets($fp, 1024);
			fclose($fp);

            $pos = strpos($res, 'VERIFIED');
			if ($pos !== false) {
				$paidUnconfirmedStatus = 0;
                $pendingStatus = 0;

				$sql = "select `order_status_id` from `order_status` where `name` = '?' and `language_id` = '?'";
                $parsed = $this->database->parse($sql, $this->language->get('order_status_paid_unconfirmed'), $this->language->getId()); 
                $results = $this->database->getRow($parsed);
                $paidUnconfirmedStatus = $results?$results['order_status_id']:NULL;

                $sql = "select `order_status_id` from `order_status` where `name` = '?' and `language_id` = '?'";
                $parsed = $this->database->parse($sql, $this->language->get('order_status_pending'), $this->language->getId()); 
                $results = $this->database->getRow($parsed);
                $pendingStatus = $results?$results['order_status_id']:NULL;

				$reference = $this->request->get('invoice', 'post');
                $sql = "update `order` set `order_status_id` = '?' where `reference` = '?' and `order_status_id` = '?'";

				$parsed = $this->database->parse($sql,  $pendingStatus, $reference, $paidUnconfirmedStatus);
                $this->database->query($parsed);
			}
		}
  	}
}
?>